> ## Documentation Index
> Fetch the complete documentation index at: https://docs.chainstream.io/llms.txt
> Use this file to discover all available pages before exploring further.

# Token - Price by Time

> Get token price at a specific timestamp

<Note>
  Get the current price of a token in USD and native currency. For historical prices, use the `/prices` endpoint or GraphQL `DEXTrades` Cube.
</Note>

**Related**: [GraphQL DEX Trades](/en/graphql/examples/dex-trades) | MCP: `token_get_price`


## OpenAPI

````yaml /en/api-reference/openapi-data-en.yaml GET /v2/token/{chain}/{tokenAddress}/price
openapi: 3.1.0
info:
  title: Services API
  description: Services API
  contact:
    name: AI
    email: ai@sx.ai
  license:
    name: MIT
  version: '1.0'
servers:
  - url: https://api.chainstream.io
    description: Production
security:
  - bearer_auth: []
  - api_key_auth: []
tags:
  - name: Blockchain
    description: Blockchain related operations
  - name: Token
    description: Token related operations
  - name: Trade
    description: Trade related operations
  - name: Wallet
    description: Wallet related operations
  - name: Dex
    description: Dex related operations
  - name: Ranking
    description: Ranking related operations
  - name: DexPool
    description: DexPool related operations
  - name: Watchlist
    description: Watchlist related operations
  - name: KYT
    description: Kyt related operations
  - name: Webhook
    description: Webhook related operations
  - name: RedPacket
    description: Redpacket related operations
  - name: IPFS
    description: Ipfs related operations
  - name: DexScreener
    description: DexScreener related operations
paths:
  /v2/token/{chain}/{tokenAddress}/price:
    get:
      tags:
        - Token
      summary: Token - Price by Time
      description: Get token price at a specific timestamp
      operationId: get.price.by.time
      parameters:
        - name: chain
          in: path
          description: A chain name listed in supported networks
          required: true
          schema:
            $ref: '#/components/schemas/ChainSymbol'
          example: sol
        - name: tokenAddress
          in: path
          description: An address of a token
          required: true
          schema:
            type: string
          example: 6p6xgHyF7AeE6TZkSmFsko444wqoP15icUSqi2jfGiPN
        - name: timestamp
          in: query
          description: Price timestamp (Unix epoch in seconds)
          required: true
          schema:
            type: integer
            format: int64
          example: 1763461274000
      responses:
        '200':
          description: Get Price By Time
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/TokenPrice'
components:
  schemas:
    ChainSymbol:
      type: string
      description: Supported blockchain chains
      enum:
        - sol
        - eth
        - bsc
    TokenPrice:
      type: object
      description: Token price
      required:
        - address
        - timestamp
        - priceInUsd
      properties:
        address:
          type: string
          description: Token address
          example: 6p6xgHyF7AeE6TZkSmFsko444wqoP15icUSqi2jfGiPN
        priceInNative:
          type:
            - string
            - 'null'
          description: Price in native token (alias)
          example: '1000'
        priceInSol:
          type:
            - string
            - 'null'
          description: Price in native token
          example: '1000'
        priceInUsd:
          type: string
          description: Price in USD
          example: '1000'
        timestamp:
          type: integer
          format: int64
          description: Timestamp
          example: 1754055151000
  securitySchemes:
    bearer_auth:
      type: http
      scheme: bearer
      bearerFormat: JWT
    api_key_auth:
      type: apiKey
      in: header
      name: X-API-KEY

````